package com.sun.corba.se.impl.encoding;

import java.nio.charset.CharsetEncoder;
import java.nio.charset.CharsetDecoder;
import java.util.WeakHashMap;
import java.util.Map;

class CodeSetCache
{
    private ThreadLocal converterCaches;
    private static final int BTC_CACHE_MAP = 0;
    private static final int CTB_CACHE_MAP = 1;
    
    CodeSetCache() {
        this.converterCaches = new ThreadLocal() {
            public Object initialValue() {
                return new Map[] { new WeakHashMap(), new WeakHashMap() };
            }
        };
    }
    
    CharsetDecoder getByteToCharConverter(Object o) {
        return (CharsetDecoder)((Map[])(Map[])this.converterCaches.get())[0].get(o);
    }
    
    CharsetEncoder getCharToByteConverter(Object o) {
        return (CharsetEncoder)((Map[])(Map[])this.converterCaches.get())[1].get(o);
    }
    
    CharsetDecoder setConverter(Object o, CharsetDecoder charsetDecoder) {
        ((Map[])(Map[])this.converterCaches.get())[0].put(o, charsetDecoder);
        return charsetDecoder;
    }
    
    CharsetEncoder setConverter(Object o, CharsetEncoder charsetEncoder) {
        ((Map[])(Map[])this.converterCaches.get())[1].put(o, charsetEncoder);
        return charsetEncoder;
    }
}
